﻿// NaverAppSetupBuilder.cpp : 응용 프로그램에 대한 진입점을 정의합니다.
//

#include "stdafx.h"
#include "NaverAppSetupBuilder.h"

#define IDS_APPSETUP_NAME               1 
#define IDS_APPSETUP_KEY	            2 
#define IDS_APPSETUP_REGISTRY			3
#define IDR_APP_SETUP                   137
#define IDR_ICONS						2000

char g_szResourceName[64] = {NULL};
ULONG g_szResourceID = -1;
HINSTANCE g_hInst;

bool CheckCommandLine(LPSTR lpCmdLine, LPSTR szAppKey, LPSTR szAppName, LPSTR szInAppSetup, LPSTR szOutAppSetup, bool* bSlient);
bool LoadSetupTemplate(LPSTR szTempAppSetup);
bool UpdateAppSetup(HANDLE hUpdateFile, LPSTR szTempAppSetup, LPSTR szInAppSetup);
bool UpdateAppIcons(HANDLE hUpdateFile, LPSTR szTempAppSetup, LPSTR szInAppSetup);
bool UpdateAppNameAndKey(HANDLE hUpdateFile, LPSTR szTempAppSetup, LPSTR szAppName, LPSTR szAppKey);
bool CopyFinalSetupFile(LPSTR szTempAppSetup, LPSTR szInAppSetup, LPSTR szOutAppSetup);

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	TCHAR	szAppName[100];						// Application 이름 {NaverPhone_QA}
	TCHAR	szAppKey[100];						// Application Key  {NaverPhone} 
	TCHAR	szInAppSetup[MAX_PATH] = {NULL};	// AppSetup.exe 
	TCHAR	szOutAppSetup[MAX_PATH] = {NULL};	// Output_AppSetup.exe
	TCHAR	szTempAppSetup[MAX_PATH] = {NULL};	// Temporary AppSetup.exe
	TCHAR	szAppRegistry[MAX_PATH] = {NULL};	// App Install Registry
	bool	bSilent = false;

	g_hInst = hInstance;

	//1. CommandLine을 Check한다.
	if (!CheckCommandLine(lpCmdLine, szAppKey, szAppName, szInAppSetup, szOutAppSetup, &bSilent))
	{
		if (!bSilent) 
			MessageBox(NULL, "[[Usage]]\n\n NaverAppSetupBuilder.exe [AppKey] [AppName] [AppSetupFullPath] [OutputFullPath] [/s]\n\n" \
							 "  - [AppKey]\t: AppKey\n" \
							 "  - [AppName]\t: App이름\n" \
							 "  - [InputFile]\t: Src Setup.exe\n" \
							 "  - [OutputFile]\t: Dest Setup.exe (Option)\n" \
							 "  - /s\t\t: messagebox slient (Option) \n",
							 "네이버 통합 Setup Builder", MB_OK);
		return 1;
	}

	//2. Temp 폴더 및 화일을 설정한다.
	if (!LoadSetupTemplate(szTempAppSetup)) 
	{
		if (!bSilent) 
			MessageBox(NULL, "Setup Template화일을 열 수 없습니다.", "네이버 통합 Setup Builder", MB_OK);
		return 1;
	}

	//3. Resource Update 초기화하기
	HANDLE hUpdateFile = BeginUpdateResource (szTempAppSetup, false);
	if ( (NULL == hUpdateFile) || (INVALID_HANDLE_VALUE == hUpdateFile) ) 
	{
		if (!bSilent) 
			MessageBox(NULL, "AppSetup화일을 열수가 없습니다.", "네이버 통합 Setup Builder", MB_OK);
		return 1;
	}

	//3.1 IDR_APPSETUP_TEMPLATE의 APP_SETUP Resource를 원본Setup화일(szInAppSetup)로 교체
	if (false == UpdateAppSetup(hUpdateFile, szTempAppSetup, szInAppSetup))
	{
		TCHAR strTemp[200];
		wsprintf(strTemp, "[%s]에 대한 정보를 읽거나 Update할 수 없습니다.", szInAppSetup);
		if (!bSilent) 
			MessageBox(NULL, strTemp, "네이버 통합 Setup Builder", MB_OK);
		return 1;
	}

	//3.2 IDR_APPSETUP_TEMPLATE의 ICON을 원본Setup화일Icon로 교체
	if (false == UpdateAppIcons(hUpdateFile, szTempAppSetup, szInAppSetup))
	{
		TCHAR strTemp[200];
		wsprintf(strTemp, "[%s]에 대한 Icon정보를 읽거나 Update할 수 없습니다.", szInAppSetup);
		if (!bSilent) 
			MessageBox(NULL, strTemp, "네이버 통합 Setup Builder", MB_OK);
		return 1;
	}

	//3.3 IDR_APPSETUP_TEMPLATE의 IDS_APPSETUP_NAME을 szAppName으로 교체
	if (false == UpdateAppNameAndKey(hUpdateFile, szTempAppSetup, szAppName, szAppKey))
	{
		TCHAR strTemp[200];
		wsprintf(strTemp, "[%s]의 String 리소스를 Update할 수 없습니다.", szInAppSetup);
		if (!bSilent) 
			MessageBox(NULL, strTemp, "네이버 통합 Setup Builder", MB_OK);
		return 1;
	}

	//wsprintf(szAppRegistry, "%s", "HKEY_CURRENT_USER\\Software\\NHN Corporation\\NaverSetup\\InstallFilePath");


	//4. Resource Update 닫기
	if (false == EndUpdateResource(hUpdateFile, false))
	{
		if (!bSilent) 
			MessageBox(NULL, "리소스를 업데이트할 수 없습니다", "네이버 통합 Setup Builder", MB_OK);
		return 1;
	}

	//6. 교체된 AppSetTemplate를 해당 Output으로 Write한다.
	if (false == CopyFinalSetupFile(szTempAppSetup, szInAppSetup, szOutAppSetup))
	{
		TCHAR strTemp[200];
		wsprintf(strTemp, "[%s]을 만들 수 없습니다.", szOutAppSetup);
		if (!bSilent) 
			MessageBox(NULL, strTemp, "네이버 통합 Setup Builder", MB_OK);
		return 1;
	}

	return 0;
}

bool UpdateAppNameAndKey(HANDLE hUpdateFile, LPSTR szTempAppSetup, LPSTR szAppName, LPSTR szAppKey)
{
	int nCntAppName = (int)_tcslen(szAppName) + 1;
	LPWSTR pUnicodeAppName = new WCHAR[nCntAppName];
	DWORD dwUnicodeCntAppName = MultiByteToWideChar(CP_ACP, NULL, szAppName, -1, pUnicodeAppName, nCntAppName);

	int nCntAppKey = (int)_tcslen(szAppKey) + 1;
	LPWSTR pUnicodeAppKey = new WCHAR[nCntAppKey];
	DWORD dwUnicodeCntAppKey = MultiByteToWideChar(CP_ACP, NULL, szAppKey, -1, pUnicodeAppKey, nCntAppKey);

	HGLOBAL hGlob = GlobalAlloc(GHND, (dwUnicodeCntAppKey + 4 + dwUnicodeCntAppName + 4) * sizeof(WCHAR) );
	LPWSTR pBufStart = (LPWSTR)GlobalLock(hGlob);
	LPWSTR pBuf = pBufStart;
	pBuf++;	

	*(pBuf++) = (WCHAR)dwUnicodeCntAppName-1;
	for(int i=0; i<(int)dwUnicodeCntAppName-1; i++)
        *(pBuf++) = pUnicodeAppName[i];
	
	if(++dwUnicodeCntAppName % 1)
        dwUnicodeCntAppName++;

	*(pBuf++) = (WCHAR)dwUnicodeCntAppKey-1;
	for(int i=0; i<(int)dwUnicodeCntAppKey-1; i++)
        *(pBuf++) = pUnicodeAppKey[i];

	if(++dwUnicodeCntAppKey % 1)
        dwUnicodeCntAppKey++;

	int nSize = sizeof(pBufStart);
	if (false == UpdateResource(hUpdateFile, RT_STRING, MAKEINTRESOURCE((IDS_APPSETUP_NAME / 16) + 1),
								MAKELANGID(LANG_KOREAN, SUBLANG_KOREAN),
								//pRes, sizeof(pRes) ))
								pBufStart, (dwUnicodeCntAppName+dwUnicodeCntAppKey) * sizeof(WCHAR) ))
								//pBufStart, sizeof(pBufStart) ))
	{
		return false;
	}
	delete pUnicodeAppName;
	delete pUnicodeAppKey;
	GlobalUnlock(hGlob);
	GlobalFree(hGlob);

	return true;
}

// 리소스 이름가져오는 CallBack Function
BOOL static CALLBACK EnumResNamesFunc(HANDLE hModule, LPCTSTR lpType, LPTSTR lpName, LONG_PTR lParam)  
{ 
	if((ULONG)lpName < 65536)//ID 
	{ 
		g_szResourceID = (ULONG)lpName;
	}
	else { //Name
		strcpy(g_szResourceName, lpName);
	}
 
    return TRUE; 
} 

bool UpdateAppIcons(HANDLE hUpdateFile, LPSTR szTempAppSetup, LPSTR szInAppSetup)
{
	HMODULE hSrcExe;
	HRSRC	hRes;
	BYTE*	lpResLock;
	HRSRC	hResLoad;
	int		nIconCount = 0;

	hSrcExe = LoadLibrary(szInAppSetup);
	if (NULL == hSrcExe)
		return false;

	char resStr[10];
	for (int i = 1;;i++)
	{
		wsprintf(resStr, "#%d", i);
		hRes = FindResource(hSrcExe, resStr, RT_ICON);
		if ( hRes ) 
		{
			hResLoad = (HRSRC)LoadResource(hSrcExe, hRes);
			if (NULL == hResLoad)
				return false;
			lpResLock = (BYTE*)LockResource(hResLoad);
			if (NULL == lpResLock)
				return false;
			
			if ( false == UpdateResource(hUpdateFile,				
									RT_ICON,          
									MAKEINTRESOURCE(i), 
									MAKELANGID(LANG_KOREAN, SUBLANG_KOREAN),  
									lpResLock,        
									SizeofResource(hSrcExe, hRes)) )
			{
				return false;
			}
		} else {
			break;
		}
	}

	EnumResourceNames(hSrcExe, RT_GROUP_ICON, (ENUMRESNAMEPROC)EnumResNamesFunc, NULL); 
	if (g_szResourceID > 0) 
		hRes = FindResource(hSrcExe, MAKEINTRESOURCE(g_szResourceID), RT_GROUP_ICON); 
	else if (_tcslen(g_szResourceName) > 0) 
		hRes = FindResource(hSrcExe, g_szResourceName, RT_GROUP_ICON); 

	if (NULL == hRes) 
		return false;

	hResLoad = (HRSRC)LoadResource(hSrcExe, hRes);
	if (NULL == hResLoad)
		return false;
	lpResLock = (BYTE*)LockResource(hResLoad);
	if (NULL == lpResLock)
		return false;

	if (false == UpdateResource(hUpdateFile, RT_GROUP_ICON, MAKEINTRESOURCE(IDR_ICONS), 
						MAKELANGID(LANG_KOREAN, SUBLANG_KOREAN),
						lpResLock, SizeofResource(hSrcExe, hRes))
	) {
		return false;
	}

	FreeLibrary(hSrcExe);

	return true;
}

bool UpdateAppSetup(HANDLE hUpdateFile, LPSTR szTempAppSetup, LPSTR szInAppSetup)
{
	bool bRet = true;

	DWORD	dwFileSize	= 0;
	LPBYTE	lpBinData	= NULL;
	DWORD	dwByteRead	= 0;
	
	HANDLE hSrcFile = CreateFile(szInAppSetup, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (NULL != hSrcFile && INVALID_HANDLE_VALUE != hSrcFile) 
	{
		dwFileSize = GetFileSize(hSrcFile, NULL);
		lpBinData = new BYTE[dwFileSize];
		ZeroMemory(lpBinData, dwFileSize);
		SetFilePointer(hSrcFile, 0, 0, FILE_BEGIN);
		ReadFile(hSrcFile, lpBinData, dwFileSize, &dwByteRead, NULL);
		if (NULL != hSrcFile) 
		{ 
			CloseHandle(hSrcFile); 
		}
		hSrcFile = NULL;

	} else 
		return false;

	if (false == UpdateResource(hUpdateFile, "APP_SETUP", MAKEINTRESOURCE(IDR_APP_SETUP),
								MAKELANGID(LANG_KOREAN, SUBLANG_KOREAN),
								lpBinData, dwFileSize))
	{
		bRet = false;
	}

	if (NULL != lpBinData) { delete lpBinData; }
	lpBinData = NULL;

	return bRet;
}

bool LoadSetupTemplate(LPSTR szTempAppSetup)
{
	TCHAR	szTempPath[MAX_PATH]  = {NULL};		// Temporary Path

	// Temp Path 및 File을 정한다.
	GetTempPath(sizeof(szTempPath), szTempPath);
	wsprintf(szTempAppSetup, "%s%08x.exe", szTempPath, GetTickCount());

	//리소스에 있는 AppSetTemplate를 Temp에 푼다
	HRSRC	hResource	= 0;
	HGLOBAL	hResData	= 0;
	DWORD	dwResSize	= 0;
	HANDLE	hFile		= NULL;
	DWORD	dwFileSize	= 0;
	DWORD	dwByteWrite = 0;
	DWORD	dwByteRead	= 0;
	LPVOID	lpData		= NULL;
	LPBYTE	lpBinData	= NULL;

	hResource = FindResource(g_hInst, MAKEINTRESOURCE(IDR_TEMPLATE_SETUP), "TEMPLATE_SETUP");
	dwResSize = SizeofResource(g_hInst, hResource);
	hResData = LoadResource(g_hInst, hResource);

	if (hResData != NULL && dwResSize != 0)
	{
		lpData = NULL;
		lpData = LockResource(hResData);

		hFile = CreateFile(szTempAppSetup, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if ( (NULL != hFile) && (INVALID_HANDLE_VALUE != hFile) ) { 
			SetFilePointer(hFile, 0, 0, FILE_BEGIN);
			WriteFile(hFile, (LPBYTE)lpData, dwResSize, &dwByteWrite, NULL);
			if (NULL != hFile) {CloseHandle(hFile);}
			hFile = NULL;
		} else {
			return false;
		}
	}

	return true;
	
}

LPTSTR GetToken(LPTSTR pszCmdLine)
{
	if(pszCmdLine[0] == 0)
		pszCmdLine++;
	TCHAR * pStart = pszCmdLine;
		
	int nLen = (int)_tcslen(pszCmdLine);

	// TrimLeft...
	while(*pStart == _T(' ') && (pStart - pszCmdLine < nLen))
		pStart++;

	if(pStart[0] == NULL)
		return NULL;

	TCHAR * pEnd;
	if(pStart[0] == _T('"'))
	{
		pStart++;
		pEnd = _tcsstr(pStart, _T("\""));
	} else
		pEnd = _tcsstr(pStart, _T(" "));

	if(pEnd)
		pEnd[0] = 0;

	if(_tcslen(pStart) == 0)
		return NULL;

	return pStart;
}

bool CheckCommandLine(LPSTR lpCmdLine,LPSTR szAppKey, LPSTR szAppName, LPSTR szInAppSetup, LPSTR szOutAppSetup, bool* bSlient)
{
	int nCmdLineLen = (int)_tcslen(lpCmdLine);
	int nCount = 0;
	int nMaxArgc = 5;
	TCHAR* pCurPos = lpCmdLine;
	TCHAR* argv[5]; 

	while(nCount < nMaxArgc)
	{
		argv[nCount] = GetToken(pCurPos);
		if(argv[nCount] == NULL)
			break;

		pCurPos = argv[nCount] + _tcslen(argv[nCount]) + 1;
		nCount++;

		if(pCurPos - lpCmdLine >= nCmdLineLen)
			break;
	}

	if ( (nCount < 3) || (nCount>5) ) 
		return false;
	else {
		_tcscpy(szAppKey, argv[0]);
		_tcscpy(szAppName, argv[1]);
		_tcscpy(szInAppSetup, argv[2]);
		if (nCount >= 4) _tcscpy(szOutAppSetup, argv[3]);
		if (nCount == 5) 
		{
			if ( (_tcscmp(argv[4], _T("/s")) == 0) || (_tcscmp(argv[4], _T("/S")) == 0) )
				*bSlient = true;

		}
		return true;
	}
}

int ExtractFilePath(LPTSTR pszFilePath)
{
	for(int i = _tcslen(pszFilePath) - 1; i >= 0; i--)
		if(pszFilePath[i] == _T('\\'))
		{
			pszFilePath[i] = 0;
			return i;
		}

	_tcscpy(pszFilePath, _T(""));
	return 0;
}

BOOL ForceDirectories(LPCTSTR pszPath)
{
	if(_tcslen(pszPath) == 0)
		return FALSE;

	TCHAR buf[MAX_PATH + 1];
	_tcscpy(buf, pszPath);
	if(buf[_tcslen(buf) - 1] == _T('\\'))
		buf[_tcslen(buf) - 1] = 0;

	int code = GetFileAttributes(buf);
	if((code != -1) && ((FILE_ATTRIBUTE_DIRECTORY & code) != 0))
		return TRUE;

	TCHAR szPrevPath[MAX_PATH + 1];
	_tcscpy(szPrevPath, buf);
	ExtractFilePath(szPrevPath);

	return (ForceDirectories(szPrevPath) && CreateDirectory(buf, 0));
}

bool CopyFinalSetupFile(LPSTR szTempAppSetup, LPSTR szInAppSetup, LPSTR szOutAppSetup)
{
	if (_tcslen(szOutAppSetup) == 0) 
	{
		_tcscpy(szOutAppSetup, szInAppSetup);
		int nPos = ExtractFilePath(szOutAppSetup);
		_tcscat(szOutAppSetup, "\\Output");
		//ForceDirectories(szOutAppSetup);
		_tcscat(szOutAppSetup, "\\New_");
		_tcsncat(szOutAppSetup, szInAppSetup+nPos+1, _tcslen(szInAppSetup)-nPos);
	}
	
	TCHAR szForcePath[MAX_PATH] = {NULL};
	_tcscpy(szForcePath, szOutAppSetup);
	ExtractFilePath(szForcePath);
	ForceDirectories(szForcePath);

	if (!CopyFile(szTempAppSetup, szOutAppSetup, false)) {
		return false;
	}
	DeleteFile(szTempAppSetup);

	return true;
}
